/*# ---------------------------------------------------------------------
#
# Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image
#                        pour la Sant�)
# Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
# Previous Authors : Laurent Guigues, Jean-Pierre Roux
# CreaTools website : www.creatis.insa-lyon.fr/site/fr/creatools_accueil
#
#  This software is governed by the CeCILL-B license under French law and
#  abiding by the rules of distribution of free software. You can  use,
#  modify and/ or redistribute the software under the terms of the CeCILL-B
#  license as circulated by CEA, CNRS and INRIA at the following URL
#  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html
#  or in the file LICENSE.txt.
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability.
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL-B license and that you accept its terms.
# ------------------------------------------------------------------------ */

//=====
// Don't edit this file. This file is generated from xml description..
//=====
#ifdef _USE_WXWIDGETS_
#ifndef __bbcreaMaracasVisuColorLayerImageView_h_INCLUDED__
#define __bbcreaMaracasVisuColorLayerImageView_h_INCLUDED__
#include "bbcreaMaracasVisu_EXPORT.h"
#include "bbtkWxBlackBox.h"

#include "wxVtkBaseView.h"

namespace bbcreaMaracasVisu
{

class bbcreaMaracasVisu_EXPORT ColorLayerImageView
 :
   public bbtk::WxBlackBox
{
  BBTK_BLACK_BOX_INTERFACE(ColorLayerImageView,bbtk::WxBlackBox);
//=====
// Don't edit this file. This file is generated from xml description..
//=====
  BBTK_DECLARE_INPUT(In,vtkImageData*);
  BBTK_DECLARE_INPUT(Active,bool);
  BBTK_DECLARE_INPUT(TypeControlsInterface,int);
  BBTK_DECLARE_INPUT(WxVtkBaseView,wxVtkBaseView *);
  BBTK_DECLARE_INPUT(WxVtkBaseView1,wxVtkBaseView *);
  BBTK_DECLARE_INPUT(WxVtkBaseView2,wxVtkBaseView *);
  BBTK_DECLARE_INPUT(lstBaseColor,std::vector<double>);
  BBTK_DECLARE_INPUT(lstGreyLevelBoundaries,std::vector<double>);
  BBTK_DECLARE_INPUT(lstTransparenceBoundaries,std::vector<double>);
  BBTK_DECLARE_INPUT(lstRangeForColorBar,std::vector<double>);
  BBTK_DECLARE_INPUT(PlainOrGradientColor,bool);
  BBTK_DECLARE_INPUT(FittingMode,int);
  BBTK_DECLARE_OUTPUT(NewImage,vtkImageData*);
  BBTK_PROCESS(Process);
  void Process();
  BBTK_CREATE_WIDGET(CreateWidget);
  void CreateWidget(wxWindow*);

  bool firsttime;

//=====
// Don't edit this file. This file is generated from xml description..
//=====
};

BBTK_BEGIN_DESCRIBE_BLACK_BOX(ColorLayerImageView,bbtk::WxBlackBox);
  BBTK_NAME("ColorLayerImageView");
  BBTK_AUTHOR("Eduardo DAVILA (Creatis)");
  BBTK_DESCRIPTION("Color Layer Image View");
  BBTK_CATEGORY("__CategoryBlackBox__");
  BBTK_INPUT(ColorLayerImageView,In,"Input Image",vtkImageData*,"");
  BBTK_INPUT(ColorLayerImageView,Active,"Active True/False (default True)",bool,"");
  BBTK_INPUT(ColorLayerImageView,TypeControlsInterface,"1 (default) All controls, 2 just transparency",int,"");
  BBTK_INPUT(ColorLayerImageView,WxVtkBaseView," 0 creaMaracasVisuViewer viewer XY,YZ ou XZ",wxVtkBaseView*,"");
  BBTK_INPUT(ColorLayerImageView,WxVtkBaseView1," 1 creaMaracasVisuViewer viewer XY,YZ ou XZ",wxVtkBaseView*,"");
  BBTK_INPUT(ColorLayerImageView,WxVtkBaseView2," 2 creaMaracasVisuViewer viewer XY,YZ ou XZ",wxVtkBaseView*,"");
  BBTK_INPUT(ColorLayerImageView,lstBaseColor,"???EED List of Base Colors in RGB format to define the color map. Requirement: must be of a size being a multiple of 3, with values between 0 and 1. For example, for 2 colors: \"1 0 0 0 0 1\". If not provided as required, the histogram is equally split into three areas, blue, yellow and red.",std::vector<double>,"");
  BBTK_INPUT(ColorLayerImageView,lstTransparenceBoundaries,"Transparence vector. (The same size of color lst).",std::vector<double>,"");

  BBTK_INPUT(ColorLayerImageView,lstGreyLevelBoundaries,"???EED List of the Grey Level Boundaries to define the color map (grey level outside the color boundaries will not be disayed). Requirement: Must have one more element than the number of colours. For example, for 2 colors: \"50 150 250\". If not provided as required, the histogram is equally split into areas, which number corresponds to the number of colors provided (3 by default).",std::vector<double>,"");

  BBTK_INPUT(ColorLayerImageView,lstRangeForColorBar,"??? EED ",std::vector<double>,"");


  BBTK_INPUT(ColorLayerImageView,PlainOrGradientColor,"true=Plane false=Gradient (Default false)",bool,"");
  BBTK_INPUT(ColorLayerImageView,FittingMode,"Choose the fitting mode between the images, the transformation can be either by Dimension (1), by Spacing (2) or by Pixel (3). If you want to make the choice through a dialog box, choose (-1). Default is by Pixel (3).",int,"");

  BBTK_OUTPUT(ColorLayerImageView,NewImage,"Image with correct Spacing",vtkImageData*,"");


BBTK_END_DESCRIBE_BLACK_BOX(ColorLayerImageView);
//=====
// Don't edit this file. This file is generated from xml description..
//=====
}
// EO namespace bbcreaMaracasVisu

#endif // __bbcreaMaracasVisuColorLayerImageView_h_INCLUDED__
#endif // _USE_WXWIDGETS_

